<?php
// $Id: gmaps_term.views-admin.inc,v 1.1.2.2 2010/02/10 14:01:47 xmarket Exp $

function _gmaps_term_views_data() {
  return _gmaps_term_views_data_point() + _gmaps_term_views_data_mo();
  
}

function _gmaps_term_views_data_point() {
  static $additional;
  $table = 'gmaps_term_point';
  
  if (is_null($additional)) {
    $additional = array();
    $schema = drupal_get_schema($table);
    $skip = array('tid' => 1);
    foreach($schema['fields'] as $name => $info) {
      if (!$skip[$name]) {
        $additional[$name] = array('field' => $name, 'serialize' => $info['serialize']);
      }
    }
  }
  
  $group = t('Term marker option');
  
  $data = array();
  $data['table']['group']  = $group;
  $data['table']['join']['term_data'] = array(
    'table' => $table,
    'left_field' => 'tid',
    'field' => 'tid',
  );
  
  foreach(gmaps_map_get_types('names') as $map_type => $map_type_label) {
    $part_title = t('Point option - !map_type', array('!map_type' => $map_type_label));
    $part_title_short = t('Point option');
    $data['point_'. $map_type] = array(
      'group' => $group,
      'title' => $part_title,
      'title short' => $part_title_short,
      'help' =>  t('Interactive and static marker option.'),
      'field' => array(
        'table' => $table,
        'field' => 'tid',
        'handler' => 'gmaps_term_handler_marker_point',
        'click sortable' => FALSE,
        'additional fields' => $additional,
        'map_type' => $map_type,
      ),
    );
  }
  
  return array($table => $data);
}

function _gmaps_term_views_data_mo() {
  static $additional;
  $table = 'gmaps_term_marker_option';
  
  if (is_null($additional)) {
    $additional = array();
    $schema = drupal_get_schema($table);
    $skip = array('tid' => 1);
    foreach($schema['fields'] as $name => $info) {
      if (!$skip[$name]) {
        $additional[$name] = array('field' => $name, 'serialize' => $info['serialize']);
      }
    }
  }
  
  $group = t('Term marker option');
  
  $data = array();
  $data['table']['group']  = $group;
  $data['table']['join']['term_data'] = array(
    'table' => $table,
    'left_field' => 'tid',
    'field' => 'tid',
  );
  
  $part_title = $part_title_short = t('Icon options');
  $data['icon'] = array(
    'group' => $group,
    'title' => $part_title,
    'title short' => $part_title_short,
    'help' =>  t('Interactive and static marker icon and protected icon options.'),
    'field' => array(
      'table' => $table,
      'field' => 'tid',
      'handler' => 'gmaps_term_handler_marker_icon',
      'click sortable' => FALSE,
      'additional fields' => $additional,
      'map_type' => $map_type,
    ),
  );
    
  return array($table => $data);
}

